SystemOrganization addCategory: #TPDBZ!

Object subclass: #Guerrero
	instanceVariableNames: 'nivelDePelea cantidadDeEnergia puntosDeVida aliados traje esferas semillasDelHermitanio tipo'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!Guerrero methodsFor: 'alianzas' stamp: 'RodolfoCaputo 10/14/2013 01:23'!
agregarAliado: unGuerrero
self aliados add: unGuerrero! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:55'!
aliados
	^ aliados! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:55'!
aliados: anObject
	aliados := anObject! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 17:54'!
aliarseCon: unGuerrero
(self puedeAliarseCon: unGuerrero) ifTrue:[ self concretarAlianzaCon: unGuerrero ] ifFalse: [ self error: 'Imposible realizar la alianza pedida' ].! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:54'!
cantidadDeEnergia
	^ cantidadDeEnergia! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:54'!
cantidadDeEnergia: anObject
	cantidadDeEnergia := anObject! !

!Guerrero methodsFor: 'alianzas' stamp: 'RodolfoCaputo 10/14/2013 01:36'!
concretarAlianzaCon: unGuerrero 
self agregarAliado: unGuerrero.
unGuerrero agregarAliado: self.! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'ricardoCascallares 10/14/2013 23:18'!
energiaSuficiente
^ self cantidadDeEnergia > 50! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 17:37'!
esBueno
^tipo esBueno.! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 17:33'!
esDebil 
^(nivelDePelea<15000)! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 01:51'!
esMasGrosoQue: unGuerrero
^((self nivelDePelea + self nivelesDePeleaAliados)> unGuerrero nivelDePelea).! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:57'!
esferas
	^ esferas! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:57'!
esferas: anObject
	esferas := anObject! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:54'!
nivelDePelea
	^ nivelDePelea! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:54'!
nivelDePelea: anObject
	nivelDePelea := anObject! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 01:49'!
nivelesDePeleaAliados
self aliados collect:[ :unAliado | unAliado nivelDePelea] sum.! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 16:58'!
puedeAliarseCon: unGuerrero 
^(unGuerrero aceptaA: self) & (self aceptaA: unGuerrero)! !

!Guerrero methodsFor: 'as yet unclassified' stamp: 'ricardoCascallares 10/14/2013 23:10'!
puedeHacer: unPoder 
^ unPoder puedeHacersePor: self! !

!Guerrero methodsFor: 'accessing' stamp: 'RodolfoCaputo 10/14/2013 01:09'!
puntosDeVida
	^ puntosDeVida! !

!Guerrero methodsFor: 'accessing' stamp: 'RodolfoCaputo 10/14/2013 01:10'!
puntosDeVida: anObject
	puntosDeVida := anObject! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:57'!
semillasDelHermitanio
	^ semillasDelHermitanio! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:57'!
semillasDelHermitanio: anObject
	semillasDelHermitanio := anObject! !

!Guerrero methodsFor: 'accessing' stamp: 'RodolfoCaputo 10/14/2013 17:36'!
tipo
	^ tipo! !

!Guerrero methodsFor: 'accessing' stamp: 'RodolfoCaputo 10/14/2013 17:36'!
tipo: anObject
	tipo := anObject! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:54'!
traje
	^ traje! !

!Guerrero methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 00:54'!
traje: anObject
	traje := anObject! !

Guerrero subclass: #Monstruo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!Monstruo methodsFor: 'alianzas' stamp: 'RodolfoCaputo 10/14/2013 16:57'!
aceptaA: unGuerrero 
^true.! !

Guerrero subclass: #Saiyajin
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!Saiyajin methodsFor: 'alianzas' stamp: 'RodolfoCaputo 10/14/2013 17:00'!
aceptaA: unGuerrero
^(unGuerrero esMasGrosoQue: self not)! !

Guerrero subclass: #Terricola
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!Terricola methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 17:58'!
aceptaA: unGuerrero
^(unGuerrero esBueno & (self meEntra: unGuerrero))! !

!Terricola methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 18:09'!
aliadosDebiles
^self aliados select: [ :unAliado | unAliado esDebil] ! !

!Terricola methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 17:30'!
cantAliadosDebiles
^self aliadosDebiles size! !

!Terricola methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 17:30'!
meEntra: unGuerrero
^(unGuerrero esDebil & (self cantAliadosDebiles >5)) not! !

!Terricola methodsFor: 'as yet unclassified' stamp: 'ricardoCascallares 10/14/2013 23:16'!
puedeHacer: unPoder
^super puedeHacer: unPoder &  (unPoder energiaConsumida: self) <500 ! !

Object subclass: #Poder
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!Poder methodsFor: 'as yet unclassified' stamp: 'ricardoCascallares 10/14/2013 23:33'!
energiaConsumida: unGuerrero
^ self energiaQueConsume! !

!Poder methodsFor: 'as yet unclassified' stamp: 'ricardoCascallares 10/14/2013 23:37'!
puedeHacersePor: unGuerrero
^ true! !

Poder subclass: #PoderColectivo
	instanceVariableNames: ''
	classVariableNames: 'energiaQueConsume'
	poolDictionaries: ''
	category: 'TPDBZ'!

!PoderColectivo class methodsFor: 'accessing' stamp: 'ricardoCascallares 10/14/2013 23:48'!
energiaQueConsume
	^ energiaQueConsume! !

!PoderColectivo class methodsFor: 'accessing' stamp: 'ricardoCascallares 10/14/2013 23:48'!
energiaQueConsume: anObject
	energiaQueConsume := anObject! !

Poder subclass: #PoderLiviano
	instanceVariableNames: 'puntosDeAtaque'
	classVariableNames: 'energiaQueConsume'
	poolDictionaries: ''
	category: 'TPDBZ'!

!PoderLiviano class methodsFor: 'accessing' stamp: 'ricardoCascallares 10/14/2013 23:49'!
energiaQueConsume
	^ energiaQueConsume! !

!PoderLiviano class methodsFor: 'accessing' stamp: 'ricardoCascallares 10/14/2013 23:49'!
energiaQueConsume: anObject
	energiaQueConsume := anObject! !

!PoderLiviano methodsFor: 'as yet unclassified' stamp: 'ricardoCascallares 10/14/2013 23:38'!
puedeHacersePor: unGuerrero
^ unGuerrero energiaSuficiente.! !

!PoderLiviano methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 01:37'!
puntosDeAtaque
	^ puntosDeAtaque! !

!PoderLiviano methodsFor: 'accessing' stamp: 'ricardocascallares 10/14/2013 01:37'!
puntosDeAtaque: anObject
	puntosDeAtaque := anObject! !

Poder subclass: #PoderPotente
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!PoderPotente methodsFor: 'as yet unclassified' stamp: 'ricardoCascallares 10/14/2013 23:34'!
energiaConsumida: unGuerrero 
^ unGuerrero cantidadDeEnergia * 0.25! !

Poder subclass: #PoderVengativo
	instanceVariableNames: ''
	classVariableNames: 'energiaQueConsume'
	poolDictionaries: ''
	category: 'TPDBZ'!

!PoderVengativo class methodsFor: 'accessing' stamp: 'ricardoCascallares 10/14/2013 23:49'!
energiaQueConsume
	^ energiaQueConsume! !

!PoderVengativo class methodsFor: 'accessing' stamp: 'ricardoCascallares 10/14/2013 23:49'!
energiaQueConsume: anObject
	energiaQueConsume := anObject! !

Object subclass: #TipoBueno
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!TipoBueno methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 17:39'!
esBueno
^true! !

Object subclass: #TipoMalo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TPDBZ'!

!TipoMalo methodsFor: 'as yet unclassified' stamp: 'RodolfoCaputo 10/14/2013 17:39'!
esBueno
^false! !
